'use strict';
const fileHelper = require('./../fileHepler');
const basePath = require('./../path');
const clog = require('./../clog');
const compressing = require('compressing');
const utils = require('./../lib/utils');


//https://www.php.cn/faq/521614.html
//https://www.npmjs.com/package/compressing
(()=>{
  let nameFile = 'versions';
  let cacheDir = `${basePath.rootDir}/cache`;
  if(!fileHelper.existFileSync(cacheDir)) {
    fileHelper.mkdirSync(basePath.rootDir,'cache');
  }
  if(!fileHelper.existFileSync(`${cacheDir}/${nameFile}`)) {
    fileHelper.mkdirSync(cacheDir,nameFile);
  }

  let name = utils.dateToTime(new Date().getTime()/1000,'str')
  let saveDir = `${basePath.rootDir}/cache/${nameFile}/${name}.zip`;
  compressing.zip.compressDir(basePath.buildDistDirectory,saveDir, {relativePath: name})
    .then(res=>{
      utils.logsLine(clog,'start')
      clog(`保存成功`, 'green');
      clog(`路径: ${fileHelper.getPlatformSurePath(saveDir)}`, 'green')
      utils.logsLine(clog)
    })
    .catch(err=>{
      utils.logsLine(clog,'start')
      clog(`保存失败`, 'red');
      clog(`路径: ${fileHelper.getPlatformSurePath(saveDir)}`, 'red')
      utils.logsLine(clog)
    })
})();

